<template>
<div>


	<button style="margin-left:20%;" type="button" class="btn btn-primary" data-toggle="modal" data-target="#modalcategoria">+ Agregar Categorias</button>
 


<!-- Modal: AGREGAR CATEGORIAS -->
<div class="modal fade" id="modalcategoria" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
  aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <!--Header-->
      <div class="modal-header">
        <h4 class="modal-title" id="myModalLabel">Categorias</h4>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">×</span>
        </button>
      </div>
      <!--Body-->
     	 	<div class="modal-body">

     	 		<div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Registro Categorias</div>

                <div class="card-body">
                    <form v-on:submit.prevent="create" method="POST">
                       
                        <div class="form-group row">
                            <label for="nombre" class="col-md-4 col-form-label text-md-right">Nombre</label>

                            <div class="col-md-6">
                                <input v-model="categoria.nombre" id="nombre" type="text" name="nombre"  required autocomplete="nombre" autofocus>>                
                            </div>
                        </div>

                        
                        <div class="form-group row">
                            <label for="descripcion" class="col-md-4 col-form-label text-md-right">Descripción</label>

                            <div class="col-md-6">
                                <input v-model="categoria.descripcion" id="descripcion" type="text" name="descripcion" required autocomplete="descripcion" >
                            </div>
                        </div>

                       <button  type="submit" class="btn btn-primary">Agregar</button>
                    </form>
                </div>
            </div>
        </div>
    </div>

     		 </div>

		</div>
	</div>
</div>



 


<!-- Modal: EDITAR CATEGORIAS -->
<div class="modal fade" id="modaleditcategorias" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
  aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <!--Header-->
      <div class="modal-header">
        <h4 class="modal-title" id="myModalLabel">Categorias</h4>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">×</span>
        </button>
      </div>
      <!--Body-->
     	 	<div class="modal-body">

     	 		<div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
              <div class="card-header">Editar Categorias</div>

                <div class="card-body">
                   
                    <form  method="POST">

                        <div class="form-group row">
                            <label for="nombre" class="col-md-4 col-form-label text-md-right">Nombre</label>

                            <div class="col-md-6">
                                <input v-model="editar.nombre" id="nombre" type="text" name="nombre"  required autocomplete="nombre" autofocus pattern="[A-Za-z\s]+[,]+{1,15}"> 
                            </div>
                        </div>

                        
                        <div class="form-group row">
                            <label for="descripcion" class="col-md-4 col-form-label text-md-right">Descripción</label>

                            <div class="col-md-6">
                                <input v-model="editar.descripcion" id="descripcion" type="text" name="descripcion" required autocomplete="descripcion" pattern="[A-Za-z\s]+[,]+{1,15}">
                            </div>
                        </div>

                       <button type="button" @click="updatecat(editar)" class="btn btn-primary">Editar</button>
						
                    </form>
                </div>
            </div>
        </div>
    </div>

     		 </div>

		</div>
	</div>
</div>

	<form  id="form" class="form-inline my-2 my-lg-0">
                <input v-model="Search" style="width:55%;" id="control" class="form-control mr-sm-2" type="text" placeholder="Search by nombre">
                <button class="btn btn-outline-success my-2 my-sm-0" type=""><i class="fa fa-search" aria-hidden="true"></i></button>
            </form>
<div class="table-wrapper-scroll-y my-custom-scrollbar">
<table class="table table-bordered table-striped mb-0">
				<thead>
					<tr>
						<th>CATEGORIAS</th>
						<th>DESCRIPCIÓN</th>
            <th>CODIGO</th>
						<th>EDITAR</th>
						<th>ELIMINAR</th>
					</tr>
				</thead>
				<tbody v-for="categoria in searchcategorias" :key="categoria.id">
					<tr>
						<td v-bind:href="categoria.uri" target="_blank" >{{categoria.nombre}}</td>
						<td >{{categoria.descripcion}}</td>
            <td >{{categoria.codigo}}</td>
						<td><button @click="editcat(categoria)" type="button" class="btn btn-primary" data-toggle="modal" data-target="#modaleditcategorias">Editar</button>	
						</td>
						<td><button type="button" class="btn btn-danger" @click="remove(categoria)">Eliminar</button></td>

					</tr>
				</tbody>
			
      </table>
</div>

     <!--    <p>page:{{pagination.total}}</p>
   <paginate style="margin-left:400px"
  :page-count="pagination.last_page"
  :click-handler="fetchdata"
  :prev-text="'Anterior'"
  :next-text="'Siguiente'"
  v-model="pagination.current_page"
  >
</paginate>-->
</div>
</template>

<script>
    export default {	

    	
		data() {
			return {
				csrf: document.head.querySelector('meta[name="csrf-token"]').getAttribute('content'),	
				categoria:{
					nombre:"",
					stock:""
				},
				editMode:false,

				Search:'',
       // buscador:1,
       editar:{},
       //pagination:{
        //current_page:1,
        //last_page:1
        //},
			}
		},
    props:["categorias"],
		mounted(){
			this.fetchdata();
		},
		computed:{
	   searchcategorias(){
     if(this.Search){
      let resultados = this.$parent.categorias.filter(c => 
        c.nombre.toLowerCase().startsWith(this.Search));
       
      resultados = [...resultados,...this.$parent.categorias.filter(c =>
        c.descripcion== this.Search)];
       return resultados
     }else{
        return this.$parent.categorias;
      }
    }
  },
		methods:{
	/*		fetchdata(page=1){
				const self = this;
				axios.get('api/categorias?page='+page).then(function(response){
					self.$parent.categorias = response.data.data.map(function (cat) {
             return cat;
          });
					
           self.pagination={
        current_page:parseInt(response.data.current_page),
        last_page:parseInt(response.data.last_page),
             }
         
				})
			},*/

      fetchdata(){
        const self = this;
        axios.get('api/categorias').then(function(response){
          self.$parent.categorias = response.data.map(function (cat) {
             return cat;
          });
        })
      },
			
		
			create(){
				axios.post("api/rcategoria",this.categoria).then(response=>{
					this.$parent.categorias.push(response.data.categorias);
					this.categoria.nombre=''
					this.categoria.descripcion=''
					console.log(response.data)
				})
        this.fetchdata();
			},

			 remove(categoria) {
                if (confirm("Esta seguro que desea eliminarlo?")) {
                    axios.delete('api/deletecat/' + categoria.id)
                        this.fetchdata();
                }else{
                      
                }
            },


			       editcat(categoria){
              let uri ='api/editar/'+ categoria.id;
                axios.get(uri).then((response) => {
                    this.editar = response.data;
                });
            },

       updatecat(categoria){
        let url ='api/update/' + categoria.id;
        axios.put(url,this.editar).then(resp=>{
          this.fetchdata();
          this.editar=resp.data;
          $('#modaleditcategorias').modal('hide');
        })
       },

     }

}

</script>

<style scoped>

body {
  margin: 0;
  background: linear-gradient(45deg, #49a09d, #5f2c82);
  font-family: sans-serif;
  font-weight: 100;
}

.container {
  position: absolute;
  top: 5%;
  left: 5%;
  transform: translate(-50%, -50%);
}

table {
  width:900px;
  margin:0 auto;
  margin-top:2%;
  border-collapse: collapse;
  overflow: hidden;
  box-shadow: 0 0 20px rgba(0,0,0,0.1);
   border-top:2px solid #ccc;
  border-left: 2px solid #ccc;
  margin-bottom:1em;
}
.my-custom-scrollbar {
  height: 500px;
overflow-x:hidden;
overflow: auto;
}
.table-wrapper-scroll-y {
display: block;
}
th,
td {
  padding:20px;
  background-color: rgba(255,255,255,0.2);
  color: #000000;
  padding: 0.5em -1em;
    border-bottom: 1px solid #ccc;
    border-right: 1px solid #ccc;

}

th {
    padding: 0.5em 1em;
    border-bottom: 1px solid #ccc;
    border-right: 1px solid #ccc;
    white-space: pre;
   background-color: rgba(255,255,255,0.2);
  color: #000000;
}

thead {
  th {
    background-color: rgba(255,255,255,0.2);
  color: #000000;
  }
}

tbody {
  tr {
    &:hover {
      background-color: rgba(255,255,255,0.3);
    }
  }
  td {
    position: relative;
    &:hover {
      &:before {
        content: "";
        position: absolute;
        left: 0;
        right: 0;
        top: -9999px;
        bottom: -9999px;
        background-color: rgba(255,255,255,0.2);
        z-index: -1;
      }
    }
  }
}




</style>